diff -Naur --exclude=CVS --exclude=configs linux/hpc/deputy.c linux-openmosix/hpc/deputy.c
--- linux/hpc/deputy.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/hpc/deputy.c	2004-02-05 02:48:27.000000000 +0100
@@ -0,0 +1,1451 @@
+/* Changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * Author(s): Moshe Bar, Amnon Shiloh
+ */
+
+
+
+#include <linux/sched.h>
+#include <linux/ptrace.h>
+#include <hpc/defs.h>
+#include <hpc/routines.h>
+#include <linux/hpc.h>
+#include <hpc/protocol.h>
+#include <hpc/comm.h>
+#include <hpc/debug.h>
+#include <asm/unistd.h>
+#include <linux/slab.h>
+#include <asm/uaccess.h>
+#include <linux/in6.h>
+#include <asm/checksum.h>
+#include <asm/pgtable.h>
+#include <asm/mmu_context.h>
+#include <linux/smp_lock.h>
+#include <linux/highmem.h>
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
+static inline int
+HAS_ASYNC(struct task_struct *p)
+{
+	process_ack(p, DREQ_CHECKSTAY);
+	return(p->mosix.prequest || p->mosix.whereto ||
+		process_told(p, (DREQ_CAPCNG|DREQ_DFSASYNC|DREQ_NICECNG|
+				DREQ_INFOCNG|DREQ_UPDOVERHEADS|DREQ_URGENT)) ||
+	(p->mosix.stay & DSTAY) ||
+	(process_told(p, DREQ_CHECKCONF) && i_am_in_a_wrong_place())
+	);
+}
+
+void
+mosix_inform_remote_of_info(void)
+{
+	struct disclosure_h d;
+	struct task_struct *p = current;
+
+	d.disclosure = p->mosix.disclosure;
+	d.uid = p->uid;
+	d.gid = p->gid;
+	d.pgrp = p->pgrp;
+	d.session = p->session;
+	d.tgid = p->tgid;
+	memcpy(d.comm, p->comm, sizeof(d.comm));
+	if(deputy_request(DEP_INFO, &d, sizeof(d), NULL, 0, 0, NULL, 0))
+		deputy_die_on_communication();
+}
+
+void
+deputy_async_requests(void)
+{
+	register struct task_struct *p = current;
+	register struct mosix_task *m = &p->mosix;
+	int w;
+
+	check_again:
+	process_ack(p, DREQ_CHECKSTAY);
+	while(m->prequest)
+		process_requests();
+	if(process_told(p, DREQ_URGENT))
+	{
+		process_ack(p, DREQ_URGENT);
+		comm_take_urgent();
+		if(deputy_request(DEP_TAKEURGENT, NULL, 0, NULL, 0, 0,
+			(void **)&w, -sizeof(w)))
+			goto check_again;
+		if(w)
+			mosix_add_to_whereto(p, w);
+	}
+	if(m->whereto)
+	{
+		follow_whereto();
+		if(!(m->dflags & DDEPUTY))
+			return;
+		goto check_again;
+	}
+	if(process_told(p, DREQ_CAPCNG))
+		sync_caps();
+#ifdef CONFIG_MOSIX_DFSA
+	if(process_told(p, DREQ_DFSASYNC))
+		deputy_resync_dfsa();
+#endif /* CONFIG_MOSIX_DFSA */
+	if(process_told(p, DREQ_NICECNG))
+	{
+		process_ack(p, DREQ_NICECNG);
+		mosix_inform_remote_of_nice();
+		goto check_again;
+	}
+	if(process_told(p, DREQ_INFOCNG))
+	{
+		process_ack(p, DREQ_INFOCNG);
+		mosix_inform_remote_of_info();
+		goto check_again;
+	}
+	if(process_told(p, DREQ_UPDOVERHEADS))
+	{
+		process_ack(p, DREQ_UPDOVERHEADS);
+		deputy_inform_remote_of_overheads();
+		goto check_again;
+	}
+	if((m->stay & DSTAY) ||
+		((process_told(p, DREQ_CHECKCONF)) && i_am_in_a_wrong_place()))
+	{
+		if(!mosix_go_home(1))
+		{
+			printk("Process %s, uid=%d, killed because it failed to migrate back \n",
+				desc_mostask(m), p->uid);
+			printk("(possible reasons are fill-up of swap-space, or network disconnection)\n");
+			send_sig(SIGKILL, p, 1);
+		}
+		done_checking_conf();
+		return;
+	}
+}
+
+static inline void
+deputy_communication_failed_msg(void)
+{
+	printk("Process %s, uid=%d, killed because it lost communication\n"
+		"with the remote node where it was running\n",
+		desc_mostask(NULL), current->uid);
+}
+
+void
+deputy_communication_failed(void)
+{
+	deputy_communication_failed_msg();
+	force_sig(SIGKILL, current);
+}
+
+NORET_TYPE void
+deputy_die_on_communication(void)
+{
+	deputy_communication_failed_msg();
+	do_exit(SIGKILL);
+}
+
+extern asmlinkage int FASTCALL(do_signal(struct pt_regs *, sigset_t *));
+
+void
+deputy_main_loop()
+{
+	register struct task_struct *p = current;
+	extern asmlinkage void do_syscall_trace(void);
+	void *head;
+	int hlen, type = 0;	/* compiler bug requires the =0 */
+	int delay_sigs = (p->mosix.dflags & (DTRACESYS1|DTRACESYS2)) != 0;
+	int has;
+
+	p->mosix.dflags &= ~(DTRACESYS1|DTRACESYS2);
+	while(p->mosix.dflags & DDEPUTY)
+	if(p->mosix.dflags & DSYNC)
+	{
+		if(HAS_ASYNC(p))
+			deputy_async_requests();
+		else if(!delay_sigs && signal_pending(p))
+			do_signal(mos_to_regs(&p->mosix), 0);
+		else
+		{
+			p->mosix.pass_regs = ALL_REGISTERS;
+			comm_send(DEP_USERMODE|USERMODE, NULL, 0, NULL, 0, 0);
+			p->mosix.dflags &= ~DSYNC;
+		}
+	}
+	else
+	{
+		has = comm_wait();
+		if(p->mosix.dflags & DFAKESIGNAL)
+		{
+			p->mosix.dflags &= ~DFAKESIGNAL;
+			evaluate_pending_signals_in_mosix_context();
+		}
+		if(!has)
+		{
+			if(!HAS_ASYNC(p))
+			{
+				if(!signal_pending(p))
+				{
+					/* so why did we wake?
+					 * the only good reason would
+					 * be a DREQ_CHECKCONF while
+					 * we are NOT in a wrong place */
+					continue;
+				}
+				if(delay_sigs)
+				{
+					spin_lock_irq(&p->sigmask_lock);
+					p->sigpending = 0;
+					spin_unlock_irq(&p->sigmask_lock);
+					continue;	/* back to sleep */
+				}
+			}
+			p->mosix.dflags |= DSYNC;
+			if(comm_send(DEP_SYNC, NULL, 0, NULL, 0, 0))
+				deputy_die_on_communication();
+		}
+		p->mosix.dflags |= DSYNC;
+		if(delay_sigs)
+			evaluate_pending_signals_in_mosix_context();
+		if((type = comm_recv(&head, &hlen)) < 0)
+			deputy_die_on_communication();
+		if(type & ANYTIME)
+		{
+			if(deputy_handle_interim_request(type, head, hlen))
+				deputy_die_on_communication();
+		}
+		else switch(type)
+		{
+		case REM_NULLMSG:
+			comm_free(head);
+			continue;
+		case REM_ASIG:
+			deputy_analyse_remote_signals((struct asig_h *)head);
+			continue;
+		case REM_SYSCALL_TRACE:
+			delay_sigs ^= 1;
+			deputy_add_rusage((struct rusage *)head);
+			comm_free(head);
+			do_syscall_trace();
+			if(!(p->mosix.dflags & DDEPUTY))
+				break;
+			if(deputy_reply(REM_SYSCALL_TRACE, NULL, 0, NULL, 0, 0,
+				delay_sigs))
+				deputy_die_on_communication();
+			continue;
+		case REM_SYSCALL:
+			deputy_syscall(head, delay_sigs);
+			p = current;	/* for "fork" son */
+			continue;
+		case REM_BRING_ME_HOME:
+		case REM_MUST_COME_HOME:
+			mosix_go_home(type == REM_MUST_COME_HOME ? 2 : 1);
+			if((p->mosix.dflags & DDEPUTY) &&
+				comm_send(type|REPLY, NULL, 0, NULL, 0, 0))
+				deputy_die_on_communication();
+			continue;
+		default:
+			printk("Process %s, uid=%d, killed because it received"
+				" an unrecognized\n" "message type (0x%x) from"
+				" the remote site where it was running\n",
+				desc_mostask(NULL), current->uid, type);
+			do_exit(SIGKILL);
+		}
+	}
+}
+
+int
+deputy_reply(int type, void *hd, int hlen, void *dat, int dlen, int um, int delay_sigs)
+{
+	register struct task_struct *p = current;
+	int err;
+
+	type |= REPLY;
+	if(!(p->mosix.dflags & DNESTED) && (delay_sigs == 2 ||
+		(!HAS_ASYNC(p) && (delay_sigs || !signal_pending(p)))))
+	{
+		p->mosix.pass_regs = ALL_REGISTERS;
+		type |= USERMODE;
+	}
+	err = comm_send(type, hd, hlen, dat, dlen, um);
+	if(type & USERMODE)
+		p->mosix.dflags &= ~DSYNC;
+	return(err);
+}
+
+void
+mosix_inform_remote_of_nice(void)
+{
+	if(deputy_request(DEP_NICE, &current->nice, sizeof(current->nice),
+							NULL, 0, 0, NULL, 0))
+		deputy_die_on_communication();
+}
+
+void
+deputy_inform_remote_of_overheads(void)
+{
+	if(deputy_request(DEP_OPCOSTS, (caddr_t)deputy_here,
+		sizeof(deputy_here), NULL, 0, 0, NULL, 0))
+		deputy_die_on_communication();
+}
+
+void
+mosix_deputy_rusage(int final)
+{
+	struct rusage *r;
+
+	if(deputy_request(DEP_RUSAGE, &final, sizeof(final), NULL, 0, 0,
+						(void **)&r, sizeof(*r)))
+	{
+		if(!(current->mosix.dflags & DFINISHED))
+			deputy_communication_failed();
+		return;
+	}
+	deputy_add_rusage(r);
+	if(final)
+		current->mosix.exit_mem = r->ru_maxrss;
+	comm_free(r);
+}
+
+int
+mosix_deputy_restore_sigcontext(struct sigcontext *frame, int *eax)
+{
+	struct restore_sigcontext_ret_h r;
+
+	current->mosix.pass_regs = ALL_REGISTERS;
+	if(deputy_request(DEP_RESTORESIGCONTEXT, &frame, sizeof(frame), NULL,
+		0, 0, (void **)&r, -sizeof(r)))
+		r.result = 1;
+	*eax = r.eax;
+	return(r.result);
+}
+
+void
+mosix_deputy_setup_frame(unsigned long sig, struct k_sigaction *ka,
+	siginfo_t info, sigset_t *oldset)
+{
+	struct setupframe_parameters_h s;
+
+	s.sig = sig;
+	s.flags = ka->sa.sa_flags;
+	s.handler = ka->sa.sa_handler;
+	s.restorer = ka->sa.sa_restorer;
+	s.set = *oldset;
+	s.ss_sp = current->sas_ss_sp;
+	s.ss_size = current->sas_ss_size;
+	if(ka->sa.sa_flags & SA_SIGINFO)
+		s.info = info;
+	current->mosix.pass_regs = ALL_REGISTERS;
+	if(deputy_request(DEP_SETUPFRAME, &s, sizeof(s), NULL, 0, 0, NULL, 0))
+		deputy_die_on_communication();
+}
+
+int
+deputy_handle_interim_request(int type, void *head, int hlen)
+{
+	switch(type)
+	{
+	case REM_NOTHING:
+		comm_free(head);
+		return(comm_send(REM_NOTHING|REPLY, NULL, 0, NULL, 0, 0));
+	case REM_PAGE:
+		return(deputy_bring_page((struct bring_page_h *)head));
+	case REM_GETTSC:
+		return(deputy_tsc());
+	case REM_MORESTRINGS:
+		return(deputy_more_strings((struct execve_more_strings_h *)head));
+	case REM_BRING_ME_REGS:
+		return(deputy_bring_me_regs((unsigned long *)head));
+	case REM_GETALOAD:
+		return(send_local_aload(REM_GETALOAD|REPLY));
+	default:
+		printk("Process %s, uid=%d, received an unexpected "
+		       "urgent request\n" "(type 0x%x) from the "
+		       "remote site where it was running\n",
+		       desc_mostask(NULL), current->uid, type);
+		comm_free(head);
+		return(-EDIST);
+	}
+}
+
+int
+deputy_wait(int expect, void **head, int *hlen)
+{
+	int type, err;
+
+	while((type = comm_recv(head, hlen)) != expect)
+	if(type < 0)
+		return(type);
+	else if(type & ANYTIME)
+	{
+		if((err = deputy_handle_interim_request(type, *head, *hlen)))
+			return(err);
+	}
+	else
+	{
+		printk("DEPUTY: Unexpected non-urgent request type %x\n", type);
+		mosix_panic("deputy_wait");
+		comm_free(*head);
+		comm_flushdata(COMM_ALLDATA);
+	}
+	return(0);
+}
+
+int
+deputy_request(int type, void *header, int hlen, void *data, int dlen,
+	int uspace, void **result, int reslen)
+{
+	register struct task_struct *p = current;
+	int wasnested = (p->mosix.dflags & DNESTED);
+	int error;
+	void *head;
+	int rhlen;
+
+	p->mosix.dflags |= DNESTED;
+	if((error = comm_send(type, header, hlen, data, dlen, uspace)))
+		goto out;
+	if((error = deputy_wait(type|REPLY, &head, &rhlen)))
+		goto out;
+	if(reslen > 0)
+	{
+		if(rhlen > reslen)
+			goto lenerr;
+		if(result)
+			*result = head;
+	}
+	else
+	{
+		if(rhlen > -reslen && reslen)
+		{
+			comm_free(head);
+			lenerr:
+			printk("deputy_request type %x: %d instead of %d\n",
+				type, rhlen, reslen);
+			error = -EDIST;
+			goto out;
+		}
+		if(reslen)
+			memcpy(result, head, rhlen);
+		comm_free(head);
+	}
+	out:
+	if(!wasnested)
+		p->mosix.dflags &= ~DNESTED;
+	return(error);
+}
+
+unsigned long
+mosix_deputy_mmap(struct file *fp, unsigned long addr, int fixed,
+	unsigned long len, unsigned long flags, unsigned long off, off_t isize,
+	nopage_t nopage)
+{
+	struct mmap_parameters_h mp;
+	int error;
+	unsigned long result;
+
+	mp.addr = addr;
+	mp.fixed = fixed;
+	mp.len = len;
+	mp.flags = flags;
+	mp.pgoff = off;
+	mp.origin = PE;
+	if((mp.fp = fp))
+	{
+		mp.dp = fp->f_dentry;
+		mp.uniq = mp.fp->f_dentry->d_inode->i_unique;
+		mp.isize = mp.fp->f_dentry->d_inode->i_size;
+	}
+	mp.nopage = nopage;
+	if((error = deputy_request(DEP_MMAP, &mp, sizeof(mp), NULL, 0, 0,
+					(void **)&result, -sizeof(result))))
+		return(error);
+	return(result);
+}
+
+long
+mosix_deputy_brk(unsigned long addr, unsigned long len)
+{
+	struct brk_parameters_h b;
+	long error;
+	long result;
+
+	b.addr = addr;
+	b.len = len;
+	if((error = deputy_request(DEP_BRK, &b, sizeof(b), NULL, 0, 0,
+		(void **)&result, -sizeof(result))))
+		result = error;
+	return(result);
+}
+
+int
+deputy_munmap(unsigned long addr, size_t len)
+{
+	struct munmap_parameters_h mp;
+	int error;
+	int result;
+
+	mp.addr = addr;
+	mp.len = len;
+	if((error = deputy_request(DEP_MUNMAP, &mp, sizeof(mp), NULL, 0, 0,
+					(void **)&result, -sizeof(result))))
+		result = error;
+	return(result);
+}
+
+int
+deputy_mprotect(unsigned long addr, size_t len, unsigned long prot)
+{
+	struct mprotect_parameters_h mp;
+	int error;
+	int result;
+
+	mp.addr = addr;
+	mp.len = len;
+	mp.prot = prot;
+	if((error = deputy_request(DEP_MPROTECT, &mp, sizeof(mp), NULL, 0, 0,
+					(void **)&result, -sizeof(result))))
+		result = error;
+	return(result);
+}
+
+void
+deputy_analyse_remote_signals(struct asig_h *s)
+{
+	register int i;
+	siginfo_t info;
+	int back = 0;
+
+	while(s->nforced--)
+	{
+		if(comm_copydata(&info, sizeof(info), 0))
+			deputy_die_on_communication();
+		force_sig_info(info.si_signo, &info, current);
+	}
+	while(s->sigs)
+	{
+		switch(i = ffz(~s->sigs) + 1)
+		{
+		case FATAL_SIGSEGV:
+			force_sig(SIGSEGV, current);
+			break;
+		case REMOTE_FILE_RELEASED:
+			mosix_rebuild_file_list();
+			break;
+		case SIGSEGV:
+		case SIGKILL:
+		case SIGVTALRM:
+		case SIGPROF:
+		case SIGBUS:
+		case SIGIOT:
+		case SIGFPE:
+		case SIGILL:
+		case SIGXCPU:
+		case SIGXFSZ:
+		case SIGPWR:
+		case SIGTRAP:
+			send_sig(i, current, 1);
+			break;
+		case SIGTERM:
+			back = 1;
+			break;
+		default:
+			printk("%s - How did signal #%d arrive at REMOTE???\n",
+			       desc_mostask(NULL), i);
+		}
+		s->sigs &= ~(1 << (i-1));
+	}
+	if(current->mosix.dflags & DINCOMING)
+		return;
+	comm_free(s);
+	if(back)
+		mosix_go_home(2);
+}
+
+#define	MAX_COPY_FROM_USER	(PAGE_SIZE)
+
+unsigned long
+deputy_copy_from_user(void *to, void *from, unsigned long size, int verify)
+{
+	struct user_copy_h u;
+	int result, non_cache;
+
+	while(size > 0)
+	{
+		if((result = copy_from_cache(to, (unsigned long)from, size,
+								&non_cache)))
+		{
+			if(!(size -= result))
+				break;
+			((char *)from) += result;
+			((char *)to) += result;
+			if(!non_cache)
+				continue;
+		}
+		u.addr = from;
+		u.size = non_cache > MAX_COPY_FROM_USER ? MAX_COPY_FROM_USER : non_cache;
+		u.verify = verify;
+		if(deputy_request(DEP_COPY_FROM_USER, &u, sizeof(u), NULL, 0, 0,
+			(void **)&result, -sizeof(result)))
+			break;
+		if(result)
+		{
+			if(result < u.size &&
+				comm_copydata(to, u.size - result, 0))
+				result = u.size;
+			size += result - u.size;
+			break;
+		}
+		if(comm_copydata(to, u.size, 0))
+			break;
+		size -= u.size;
+		((char *)from) += u.size;
+		((char *)to) += u.size;
+	}
+	return(size);
+}
+
+#define	MAX_COPY_TO_USER	(2*PAGE_SIZE)
+
+unsigned long
+deputy_copy_to_user(void *to, void *from, unsigned long size, int verify)
+{
+	struct user_copy_h u;
+	int result;
+	int non_cache;
+
+	while(size > 0)
+	{
+		if((result = copy_to_cache((unsigned long)to, from, size,
+								&non_cache)))
+		{
+			if(!(size -= result))
+				break;
+			((char *)from) += result;
+			((char *)to) += result;
+			if(!non_cache)
+				continue;
+		}
+		u.addr = to;
+		u.size = non_cache > MAX_COPY_TO_USER ? MAX_COPY_TO_USER : non_cache;
+		u.verify = verify;
+		if(deputy_request(DEP_COPY_TO_USER, &u, sizeof(u),
+			from, u.size, 0, (void **)&result, -sizeof(result)))
+			break;
+		if(result)
+		{
+			size += result - u.size;
+			break;
+		}
+		size -= u.size;
+		((char *)from) += u.size;
+		((char *)to) += u.size;
+	}
+	return(size);
+}
+
+unsigned long
+deputy_clear_user(void *to, int size, int verify)
+{
+	struct user_copy_h u;
+	int result;
+	int non_cache;
+
+	while(size > 0)
+	{
+		if((result = zero_cache(to, size, &non_cache)))
+		{
+			if(!(size -= result))
+				break;
+			((char *)to) += u.size;
+			if(!non_cache)
+				continue;
+		}
+		u.addr = to;
+		u.size = non_cache;
+		u.verify = verify;
+		if(deputy_request(DEP_CLEAR_USER, &u, sizeof(u), NULL, 0, 0,
+			(void **)&result, -sizeof(result)))
+			break;
+		if(result < 0)
+		{
+			size = result;
+			break;
+		}
+		size -= non_cache;
+		if(result)
+		{
+			size += result;
+			break;
+		}
+	}
+	return(size);
+}
+
+long
+deputy_strncpy_from_user(char *to, char *from, int max, int verify)
+{
+	struct user_copy_h u;
+	int result;
+	int non_cache;
+	int read = 0;
+	char *oto = to;
+	int omax = max;
+
+	while(max > 0)
+	{
+		if((result = copy_from_cache(to, (unsigned long)from, -max,
+								&non_cache)))
+		{
+			if(non_cache == -1)
+				result--;
+			read += result;
+			if(!(max -= result))
+				break;
+			to += result;
+			from += result;
+			if(!non_cache)
+				continue;
+		}
+		if(non_cache == -1)	/* 0 encountered */
+			break;
+		u.addr = from;
+		u.size = non_cache;
+		u.verify = verify;
+		if(deputy_request(DEP_STRNCPY_FROM_USER, &u, sizeof(u), NULL, 0, 0,
+			(void **)&result, -sizeof(result)))
+		{
+			result = -EFAULT;
+			break;
+		}
+		if(result < 0)
+			break;
+		if(result && comm_copydata(to, result, 0))
+		{
+			result = -EFAULT;
+			break;
+		}
+		from += result;
+		to += result;
+		read += result;
+		max -= result;
+		if(result != non_cache)
+			break;
+	}
+	if(result >= 0)
+	{
+		result = read;
+		if(omax && read < omax)
+			oto[read] = '\0';
+	}
+	return(result);
+}
+
+long
+deputy_strnlen_user(char *from, long len)
+{
+	long result;
+	long read = 0;
+	int non_cache;
+	struct strnlen_user_h h;
+	int error = 0;
+
+	while(1)
+	{
+		result = strlen_cache(from, &non_cache);
+		read += result;
+		if(non_cache == -1)	/* 0 encountered */
+			break;
+		from += result;
+		if(read > len)
+			break;
+		if(!non_cache)
+			continue;
+		h.addr = from;
+		h.len = len - read;
+		if(deputy_request(DEP_STRNLEN_USER, (void *)&h, sizeof(h),
+			NULL, 0, 0, (void **)&result, -sizeof(result)) ||
+				result == 0)
+		{
+			error = 1;
+			break;
+		}
+		if(result > non_cache)
+			result = non_cache;
+		read += result;
+		if(read > len)
+			break;
+		from += result;
+	}
+	result = error ? 0 : (read > len ? len+1 : read);
+	return(result);
+}
+
+int
+deputy_verify_write(void *addr, unsigned long size)
+{
+	struct user_copy_h u;
+	int result;
+
+	u.addr = addr;
+	u.size = size;
+	if(all_in_cache((unsigned long)addr, size, 1))
+		result = 1;
+	else if(deputy_request(DEP_VERIFY_WRITE, &u, sizeof(u), NULL, 0, 0,
+		(void **)&result, -sizeof(result)))
+		result = 0;
+	return(result);
+}
+
+unsigned int
+deputy_csum_partial_copy_from_user(const char *src, char *dst, int len, int sum,
+							int *err_ptr)
+{
+	struct user_csum_copy_h u;
+	struct user_csum_copy_ret_h r;
+
+	/* must not play around with partial results, because unlike
+	 * "deputy_copy_from_user", we may not break the buffer
+	 * (at least not into non-4-byte-aligned segments, for now).
+	 */
+	if(any_in_cache((unsigned long)src, len))
+	{
+		if(deputy_copy_from_user(dst, (char *)src, len, 1))
+		{
+			*err_ptr |= 1;
+			return(sum);
+		}
+		return(csum_partial(dst, len, sum));
+	}
+	while(len > 0)
+	{
+		u.addr = (void *)src;
+		u.len = len > MAX_COPY_FROM_USER ? MAX_COPY_FROM_USER : len;
+		u.sum = sum;
+		if(deputy_request(DEP_CSUM_COPY_FROM_USER, &u, sizeof(u),
+			NULL, 0, 0, (void **)&r, -sizeof(r)))
+		{
+			*err_ptr |= 1;
+			return(0);
+		}
+		sum = r.newsum;
+		if(r.error || comm_copydata(dst, len, 0))
+		{
+			*err_ptr |= 1;
+			return(sum);
+		}
+		len -= u.len;
+		((char *)src) += u.len;
+		dst += u.len;
+	}
+	return(sum);
+}
+
+unsigned int
+deputy_csum_partial_copy_to_user(const char *src, char *dst, int len, int sum,
+							int *err_ptr)
+{
+	unsigned int newsum = csum_partial(src, len, sum);
+
+	if(deputy_copy_to_user(dst, (char *)src, len, 1))
+		*err_ptr = -EINVAL;
+	return(newsum);
+}
+
+struct int6 {int x[6];};
+
+void
+deputy_syscall(struct syscall_h *s, int delay_sigs)
+{
+	register struct task_struct *p = current;
+	extern void *sys_call_table[];
+	long (*func)(struct int6);
+	struct syscall_ret_h r;
+	int n = s->n;
+	struct pt_regs regs;
+	char *cdata, *tofree;
+	int l;
+
+	if(p->mosix.deputy_regs)
+		regs = *(mos_to_regs(&p->mosix));
+	memcpy((caddr_t)&regs, (caddr_t)s->args, sizeof(s->args));
+	open_ucache_envelope(s);
+	comm_free(s);
+	switch(n)
+	{
+		/* Add to this list all machine-dependent system-calls that
+		 * take the parameters' address, assuming it is the process'
+		 * registers: Such routines are all in "arch/i386/ * / *"
+		 */
+	case __NR_fork:
+	case __NR_vfork:
+	case __NR_clone:
+	case __NR_execve:
+	case __NR_iopl:
+	case __NR_ioperm:
+	case __NR_sigsuspend:
+	case __NR_rt_sigsuspend:
+	case __NR_sigreturn:
+	case __NR_rt_sigreturn:
+	case __NR_sigaltstack:
+	case __NR_vm86old:
+	case __NR_vm86:
+		if(delay_sigs)
+			p->mosix.dflags |= DTRACESYS1;
+		/* (for the son to set "delay_sigs") */
+		r.ret = call_with_regs((void *)sys_call_table[n],
+				       &regs, &regs);
+		p->mosix.dflags &= ~DTRACESYS1;
+		if(p->mosix.deputy_regs ||
+		   !(current->mosix.dflags & DDEPUTY))
+			/* sorry, cannot keep it in "regs" after we return */
+			*(mos_to_regs(&p->mosix)) = regs;
+		break;
+	default:
+		func = (__typeof__(func)) sys_call_table[n];
+		r.ret = func(*((struct int6 *)&regs));
+		p = current;
+		break;
+	}
+	if(!(p->mosix.dflags & DDEPUTY))
+	{
+		mos_to_regs(&current->mosix)->eax = r.ret;
+		return;
+	}
+	cdata = deputy_pack_read_cache_data(&l, &r, &tofree);
+	cli();
+	r.deputytime = p->mosix.deputytime;
+	p->mosix.deputytime = 0;
+	sti();
+	if(deputy_reply(REM_SYSCALL, &r, sizeof(r), cdata, l, 0, delay_sigs))
+	{
+		if(tofree)
+			kfree(tofree);
+		deputy_die_on_communication();
+	}
+	if(tofree)
+		kfree(tofree);
+}
+
+void
+mosix_deputy_rlimit(int resource, struct rlimit r)
+{
+	struct rlimit_h l;
+
+	l.resource = resource;
+	l.limit = r;
+	deputy_request(DEP_RLIMIT, &l, sizeof(l), NULL, 0, 0, NULL, 0);
+}
+
+int
+deputy_bring_page(struct bring_page_h *b)
+{
+	struct file *fp = b->fp;
+	struct vm_area_struct v;
+	struct page_ret_h r;
+	int err;
+	int address = b->offset;
+	struct page *page;
+	register struct task_struct *p = current;
+
+	v.vm_start = v.vm_pgoff = 0;
+	v.vm_end = address + PAGE_SIZE;
+	v.vm_mm = p->mm;	/* (eg. NULL) */
+	v.vm_file = fp;
+	v.vm_flags = 0;		/* anything really, but VM_SHARED */
+
+	deeper_sleep();
+	page = b->nopage(&v, address, 0);
+	lighter_sleep();
+	if(page == NOPAGE_OOM)
+	{
+		r.ret = -ENOMEM;
+		page = 0;
+	}
+	else
+		r.ret = page ? 0 : -EFBIG;
+	comm_free(b);
+	cli();
+	r.deputytime = p->mosix.deputytime;
+	p->mosix.deputytime = 0;
+	sti();
+	err = deputy_reply(REM_PAGE, &r, sizeof(r),
+		page ? kmap(page) : NULL, page ? PAGE_SIZE : 0, 0, 2);
+	if(page)
+	{
+		kunmap(page);
+		__free_page(page);
+	}
+	return(err);
+}
+
+int
+deputy_tsc(void)
+{
+	u64 r;
+
+	rdtsc(*((unsigned long *)&r), *(((unsigned long *)&r) + 1));
+	return(deputy_reply(REM_GETTSC|REPLY, &r, sizeof(r), NULL, 0, 0, 2));
+}
+
+void
+deputy_add_rusage(struct rusage *r)
+{
+	register struct task_struct *p = current;
+	int64_t ut = r->ru_utime.tv_sec * (int64_t)HZ +
+						r->ru_utime.tv_usec*HZ/MILLION;
+	int64_t st = r->ru_stime.tv_sec * (int64_t)HZ +
+						r->ru_stime.tv_usec*HZ/MILLION;
+
+	cli();
+	p->times.tms_utime += ut;
+	p->times.tms_stime += st;
+	sti();
+	p->min_flt += r->ru_minflt;
+	p->maj_flt += r->ru_majflt;
+	p->nswap += r->ru_nswap;
+}
+
+void
+mosix_deputy_count_args(char **argp, char **envp, int *argc, int *envc)
+{
+	struct execve_counts_h e;
+	struct execve_counts_ret_h r;
+
+	e.argp = argp;
+	e.envp = envp;
+	if(deputy_request(DEP_EXECVE_COUNTS, &e, sizeof(e), NULL, 0, 0,
+		(void **)&r, -sizeof(r)))
+		*argc = -EFAULT;
+	else
+	{
+		*argc = r.argc;
+		*envc = r.envc;
+	}
+}
+
+static inline int
+fill_strings_page(int pgno, int len)
+{
+	struct linux_binprm *bprm;
+	struct page *page;
+	char *kaddr;
+	int ret;
+
+	if(!pgno || len == 0)
+		return(0);
+	if(!(bprm = current->mosix.inexec) || pgno < 0 ||
+		pgno > MAX_ARG_PAGES ||
+		len < 0 || len > PAGE_SIZE || bprm->page[pgno-1])
+	{
+		printk("%s - Improper strings-page(%d:%d)\n",
+			desc_mostask(NULL), pgno, len);
+		comm_flushdata(COMM_ALLDATA);
+		return(-EFAULT);
+	}
+	if(!(page = alloc_page(GFP_HIGHUSER)))
+	{
+		comm_flushdata(COMM_ALLDATA);
+		return(0); /* error will be detected by missing the page */
+	}
+	bprm->page[pgno-1] = page;
+	kaddr = kmap(page);
+	ret = comm_copydata(kaddr + (PAGE_SIZE - len), len, 0);
+	kunmap(page);
+	return(ret);
+}
+
+int
+mosix_deputy_bring_strings(struct linux_binprm *bprm, char *filename,
+						char **envp, char **argp)
+{
+	struct execve_bring_strings_h b;
+	struct execve_bring_strings_ret_h r;
+	int i;
+
+	b.p = bprm->p;
+	b.filename = filename;
+	b.envp = envp;
+	b.envc = bprm->envc;
+	b.argp = argp;
+	b.argc = bprm->argc;
+	if(deputy_request(DEP_BRING_STRINGS, &b, sizeof(b), NULL, 0, 0,
+		(void **)&r, -sizeof(r)))
+		return(-ENOMEM);
+	if(r.result)
+	{
+		comm_flushdata(COMM_ALLDATA);
+		return(r.result);
+	}
+	bprm->p = r.p;
+	bprm->exec = r.exec;
+	fill_strings_page(r.pgno, r.len);
+	for(i = r.p / PAGE_SIZE ; i < MAX_ARG_PAGES ; i++)
+	if(!bprm->page[i])
+	  /* "fill_strings_page" or one of the "deputy_more_strings" failed */
+		return(-EAGAIN);
+	return(0);
+}
+
+int
+deputy_more_strings(struct execve_more_strings_h *m)
+{
+	int result = fill_strings_page(m->pgno, m->len);
+
+	comm_free(m);
+	if(result == -EAGAIN)
+		result = 0;
+	return(result);
+}
+
+int
+deputy_bring_me_regs(unsigned long *bring)
+{
+	current->mosix.pass_regs |= *bring & current->mosix.deputy_regs;
+	comm_free(bring);
+	return(comm_send(REM_BRING_ME_REGS|REPLY, NULL, 0, NULL, 0, 0));
+}
+
+int
+mosix_deputy_setup_args(int how, unsigned long *start_stack_p)
+{
+	struct execve_setup_args_h e;
+	struct execve_setup_args_ret_h r;
+	register struct linux_binprm *bprm = current->mosix.inexec;
+	unsigned int i;
+	int err;
+	struct page *page;
+	char *kaddr = NULL;
+
+	e.create = 1;
+	for(i = 0 ; i < MAX_ARG_PAGES-1 ; i++)
+	if((page = bprm->page[i]))
+	{
+		e.how = SETUP_ARGS_NOTYET;
+		e.pgno = i+1;
+		e.len = (i+1) * PAGE_SIZE - bprm->p;
+		if(e.len > PAGE_SIZE)
+			e.len = PAGE_SIZE;
+		kaddr = kmap(page);
+		err = comm_send(DEP_SETUP_ARGS, &e, sizeof(e),
+					kaddr + (PAGE_SIZE - e.len), e.len, 0);
+		kunmap(page);
+		if(err)
+			return(-EDIST);
+		e.create = 0;
+	}
+	e.exec = bprm->exec;
+	e.argc = bprm->argc;
+	e.envc = bprm->envc;
+	e.personality = current->personality;
+	e.how = how;
+	if((page = bprm->page[MAX_ARG_PAGES-1]))
+	{
+		e.pgno = MAX_ARG_PAGES;
+		e.len = MAX_ARG_PAGES * PAGE_SIZE - bprm->p;
+		if(e.len > PAGE_SIZE)
+			e.len = PAGE_SIZE;
+		kaddr = kmap(page);
+	}
+	else
+		e.len = e.pgno = 0;
+	e.p = bprm->p;
+	err = deputy_request(DEP_SETUP_ARGS, &e, sizeof(e),
+		e.len ? kaddr + (PAGE_SIZE - e.len) : NULL, e.len, 0,
+						(void **)&r, -sizeof(r));
+	if(page)
+		kunmap(page);
+	if(err)
+		return(-EDIST);
+	bprm->loader = r.loader;
+	bprm->exec = r.exec;
+	bprm->p = r.p;
+	for(i = 0 ; i < MAX_ARG_PAGES ; i++)
+	if(bprm->page[i])
+	{
+		__free_page(bprm->page[i]);
+		bprm->page[i] = 0;
+	}
+	if(start_stack_p)
+		*start_stack_p = r.start_stack;
+	return(r.reply);
+}
+
+int
+mosix_deputy_exec_mmap(char *filename)
+{
+	int r;
+
+	flush_ucache();
+	if(deputy_request(DEP_EXEC_MMAP, NULL, 0, NULL, 0, 0,
+						(void **)&r, -sizeof(r)))
+		return(-ENOMEM);
+	if(!r)
+		mosix_clear_all_held_files(current);
+	return(r);
+}
+
+int
+mosix_deputy_dump_thread(struct user *u)
+{
+	return(deputy_request(DEP_DUMP_THREAD, NULL, 0, NULL, 0, 0,
+		(void **)u, -sizeof(struct user)));
+}
+
+void
+mosix_deputy_init_aout_mm(struct exec *ex)
+{
+	deputy_request(DEP_INIT_AOUT_MM, ex, sizeof(*ex), NULL, 0, 0, NULL, 0);
+}
+
+unsigned long
+mosix_deputy_elf_setup(char *p, int argc, int envc, struct elfhdr *exec,
+	unsigned long addr, unsigned long load_bias,
+	unsigned long interp_load_addr, int ibcs,
+	int add_arg_start, unsigned long elf_brk, unsigned long end_code,
+	unsigned long start_code, unsigned long start_data,
+	unsigned long end_data, unsigned long elf_bss,
+	unsigned long personality, struct elf_tables_extras *extras)
+{
+	struct execve_elf_setup_h e;
+	unsigned long r;
+
+	e.p = p;
+	e.argc = argc;
+	e.envc = envc;
+	if((e.hasexec = (exec != NULL)))
+	{
+		e.exec_e_phoff = exec->e_phoff;
+		e.exec_e_phnum = exec->e_phnum;
+		e.exec_e_entry = exec->e_entry;
+	}
+	e.addr = addr;
+	e.load_bias = load_bias;
+	e.interp_load_addr = interp_load_addr;
+	e.ibcs = ibcs;
+	e.extras = *extras;
+	e.add_arg_start = add_arg_start,
+	e.elf_brk = elf_brk;
+	e.end_code = end_code;
+	e.start_code = start_code;
+	e.end_data = end_data;
+	e.start_data = start_data;
+	e.elf_bss = elf_bss;
+	e.personality = personality;
+
+	if(deputy_request(DEP_ELF_SETUP, &e, sizeof(e), NULL, 0, 0,
+		(void **)&r, -sizeof(r)))
+	{
+		if(current->mosix.dflags & DDEPUTY)
+			deputy_communication_failed();
+		r = (unsigned long)e.p;	/* we did nothing, keep same */
+	}
+	return(r);
+}
+
+void
+mosix_deputy_fix_elf_aout_interp(unsigned bss, unsigned data, unsigned text)
+{
+	struct execve_fix_elf_aout_h f;
+
+	f.bss = bss;
+	f.data = data;
+	f.text = text;
+	deputy_request(DEP_FIX_ELF_AOUT, &f, sizeof(f), NULL, 0, 0, NULL, 0);
+}
+
+int
+mosix_deputy_list_vmas(struct vmalist **vmasp, unsigned long *argstartp,
+	unsigned long *argendp)
+{
+	struct list_vmas_ret_h r;
+
+	if(deputy_request(DEP_LIST_VMAS, NULL, 0, NULL, 0, 0, (void **)&r,
+		-sizeof(r)) || r.n < 0)
+		return(-1);
+	if(r.n == 0)
+		*vmasp = NULL;
+	else
+	{
+		if(!(*vmasp = kmalloc(r.n*sizeof(struct vmalist), GFP_KERNEL)))
+			return(-1);
+		if(comm_copydata(*vmasp, r.n * sizeof(struct vmalist), 0))
+			return(-1);
+	}
+	*argstartp = r.argstart;
+	*argendp = r.argend;
+	return(r.n);
+}
+
+/*
+ * migrated away - shed memory etc.
+ */
+void
+deputy_startup(void)
+{
+	register struct task_struct *p = current;
+
+	exit_mm(p);
+	p->mosix.pages_i_bring = 0;
+	read_lock(&tasklist_lock);
+	p->mosix.ancesstor = NULL;
+	read_unlock(&tasklist_lock);
+#ifdef CONFIG_MOSIX_DFSA
+	tell_process(p, DREQ_NOTUPTODATE);
+#endif /* CONFIG_MOSIX_DFSA */
+}
+
+int
+mosix_deputy_personality(unsigned long personality)
+{
+	int result;
+
+	if(deputy_request(DEP_PERSONALITY, &personality, sizeof(personality),
+		NULL, 0, 0, (void **)&result, -sizeof(result)))
+		return(-1);
+	return(result);
+}
+
+int
+mosix_deputy_dump_fpu(struct user_i387_struct *f)
+{
+	int r;
+
+	if(deputy_request(DEP_DUMP_FPU, NULL, 0, NULL, 0, 0,
+		(void **)&r, -sizeof(r)))
+		return(0);
+	if(r && comm_copydata(f, sizeof(*f), 0))
+		return(0);
+	return(r);
+}
+
+int
+mosix_deputy_fork(struct task_struct *son, int migrated, unsigned long usp)
+{
+	struct mosix_task *m = &current->mosix;
+	void *head;
+	int hlen;
+	int type;
+	int where;
+	mosix_link *sonsock = NULL;
+	struct fork_h f;
+	int n;
+
+	f.usp = usp;
+	f.do_forkmigrate = !migrated;
+	f.pid = son->pid;
+	f.tgid = son->tgid;
+	resend:
+	m->pass_regs = ALL_REGISTERS & ~BIT_OF_REGISTER(eax);
+	if(comm_send(DEP_PLEASE_FORK, &f, sizeof(f), NULL, 0, 0))
+	{
+		bad:
+		if(sonsock)
+			comm_close(sonsock);
+		deputy_communication_failed();
+		return(-EDIST);
+	}
+	son->mosix.deputy_regs = m->deputy_regs;
+	while(1)
+		switch(type = comm_recv(&head, &hlen))
+		{
+		default:
+			if(type < 0)
+				goto bad;
+			if(!(type & ANYTIME))
+			{
+				printk("Unexpected reply (0x%x) to fork request"
+				       "\n", type);
+				goto bad;
+			}
+			if(deputy_handle_interim_request(type, head, hlen))
+				goto bad;
+			break;
+		case REM_MUST_COME_HOME:
+		case REM_BRING_ME_HOME:
+			/* comm_free(head); not needed - it's empty */ 
+		go_home_first:
+			if(sonsock)
+			{
+				comm_close(sonsock);
+				sonsock = NULL;
+			}
+			if(passto((type == REM_MUST_COME_HOME) ?
+				  MUSTGOHOME : GOBACKHOME, 0))
+				return(-EAGAIN);
+		came_home:
+			if(sonsock)
+			{
+				comm_close(sonsock);
+				sonsock = NULL;
+			}
+			son->mosix.whereami = 0;
+			undeputy(son);
+			return(0);
+		case REM_BRING_ME_TO:
+			where = *((int *)head);
+			comm_free(head);
+			if(sonsock)
+			{
+				comm_close(sonsock);
+				sonsock = NULL;
+			}
+			if(!passto(where, 0))
+			{
+				if(!(m->dflags & DDEPUTY))
+					goto came_home;
+				son->mosix.whereami = m->whereami;
+				f.do_forkmigrate = 0;
+				goto resend;
+			}
+			if(comm_send(REM_BRING_ME_TO|REPLY, NULL, 0, NULL, 0,0))
+				goto bad;
+			break;
+		case REM_CONSIDERING:
+			/* comm_free(head); not needed - it's empty */ 
+			if(sonsock)
+			{
+				comm_close(sonsock);
+				sonsock = NULL;
+			}
+			n = m->nmigs;
+			coordinate(BALANCE, 1);
+			f.do_forkmigrate = 0;	/* once only */
+			if(!(m->dflags & DDEPUTY))
+				goto came_home;
+			son->mosix.whereami = m->whereami;
+			if(m->nmigs != n)
+				goto resend;
+			break;
+		case REM_CONNECT_TO:
+			if(sonsock)
+				mosix_panic("Dup REM_CONNECT_TO");
+			sonsock = comm_open(COMM_TOADDR, (mosix_addr *)head,
+					    comm_connect_timo);
+			comm_free(head);
+			n = (sonsock != NULL);
+			if(comm_send(REM_CONNECT_TO|REPLY, &n, sizeof(n),
+				     NULL, 0, 0))
+				goto bad;
+			break;
+		case DEP_PLEASE_FORK|REPLY:
+			n = *((int *)head);
+			comm_free(head);
+			if(n)
+				goto go_home_first;
+			if(!sonsock)
+			{
+				mosix_panic("deputy_fork: no sonsock");
+				goto go_home_first;
+			}
+			son->mosix.dflags |= (DDEPUTY|DSYNC|
+					      (m->dflags & DDUMPABLE));
+			comm_use(son, sonsock);
+			return(0);
+		}
+}
+
+//EXPORT_SYMBOL(deputy_copy_from_user);
+//EXPORT_SYMBOL(deputy_copy_to_user);
